/*
LCD 16 caratteri x 2 righe
pin del circuito LCD:
 * LCD RS pin to digital pin 7 
 * LCD Enable pin to digital pin 6
 * LCD D4 pin al digital pin 5 +
 * LCD D5 pin al digital pin 4 +
 * LCD D6 pin al digital pin 3 +
 * LCD D7 pin al digital pin 2 +
 * LCD R/W pin al ground
 * LCD VSS pin al ground
 * LCD VCC pin al 5V
 * 10K pot:
 * ends to +5V and ground
 * wiper to LCD VO pin (pin 3)
********************************************** 
pin dei tasti:
 *Tasto indietro al digital pin 6
 *Tasto avanti al digital pin 7
 *Tasto conferma al digital pin 8
*********************************************** 
pin controllo motore posto in OUT A:
 *pin controllo 1 al digital pin 10  
 *pin controllo 2 al digital pin 13
 *pin enableA per la velocità al digital pin PWM 9
*/

// libreria dello schermo LCD
#include <LiquidCrystal.h>
//definizione dei pin dei tasti e del motore
#define pinMotoreA  10
#define pinMotoreB  13
#define pinMotoreE  5

#define pinIndietro  6
#define pinAvanti  7
#define pinConferma  A0
//creo un carattere custom un blochetto tutto nero
byte blocco[8] =
{
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111
};
//definizione schermata iniziale
static char Intro0[15] = "OPEN";
static char Intro1[15] = "ROTOMOLDER";
static char Intro2[15] = "FabLab SPQwoRk";
//definizione schermata menu principale
static char Posizione1[15] = ">> Direction";
static char Posizione2[15] = ">> Velocity";
static char Posizione3[15] = ">> Program";
// inizializzazione dei pin dello schermo LCD
LiquidCrystal lcd(7, 6, A5, A4, A3, A2);
//variabili
int vel =0;
void setup() {
  // dichiara il numero di caratteri e di righe del nostro schermo
  lcd.begin(16, 2);
  //attivo il nuovo carattere
  lcd.createChar(0, blocco);
  //definizione stato dei pin
  pinMode(pinMotoreA, OUTPUT);
  pinMode(pinMotoreB, OUTPUT);
  pinMode(pinMotoreE, OUTPUT);
  pinMode(pinIndietro, INPUT);
  pinMode(pinAvanti, INPUT);
  pinMode(pinConferma, INPUT);
  //schermata di reset
   for(int n = 0; n < 16; n++)
  {
    lcd.setCursor(n,0);
    lcd.write(byte(0));
    lcd.setCursor(n,1);
    lcd.write(byte(0));
    delay(50);
  }
  // schermata Principale
  Intro();
 Serial.begin(9600);
}

void loop() {

  lcd.setCursor(0, 1);
      int avanti=digitalRead(pinAvanti);
    int indietro=digitalRead(pinIndietro);
    int conferma=digitalRead(pinConferma);
    if (avanti==HIGH || indietro ==HIGH || conferma == HIGH){
      Menu();}
}
void Intro(){
    lcd.clear();
    lcd.setCursor(0,1);
    lcd.write(" ");
 for(int n = 0; n < 4; n++)
  {
    lcd.setCursor(n,0);
    lcd.write(Intro0[n]);
    delay(50);
  }     
   lcd.setCursor(4,0);
   lcd.write("  ");
   for(int n = 0; n < 16; n++)
     {
    lcd.setCursor(n+6,0);
    lcd.write(Intro1[n]);
    delay(50);
  }     
   for(int n = 0; n < 16; n++)
   
  {
    lcd.setCursor(n+1,1);
    lcd.write(Intro2[n]);
    delay(50);
  } 
 
    lcd.setCursor(15,1);
    lcd.write(" ");

 
}
void Menu(){
  boolean PosizioneSelezionata = false;
    int avanti=digitalRead(pinAvanti);
    int indietro=digitalRead(pinIndietro);
    int conferma=digitalRead(pinConferma);
lcd.setCursor(0,0);
lcd.write("SELECT VELOCITY ");
if(avanti==HIGH && vel<3){
vel++;}
else if(indietro==HIGH && vel>0){vel--;}
Serial.println("vel ="+ vel);
delay(500);
switch(vel){
case 0:{
        lcd.setCursor(0,1);
        lcd.write("   MOTOR STOP!  ");
        if (conferma==HIGH){
        Serial.println("Fermo");
        digitalWrite(pinMotoreA,LOW);
        digitalWrite(pinMotoreB,LOW);}
        break;}
case 1:{
        lcd.setCursor(0,1);
        lcd.write("  MEDIUM SPEED  ");
        if (conferma==HIGH){
         Serial.println("Lento");
        digitalWrite(pinMotoreA,HIGH);
        digitalWrite(pinMotoreB,LOW);
        analogWrite(pinMotoreE, 125);} 
        break;}
case 2:{ 
        lcd.setCursor(0,1);
        lcd.write("   HIGH SPEED   "); 
        if (conferma==HIGH){
         Serial.println("Veloce");
        digitalWrite(pinMotoreA,HIGH);
        digitalWrite(pinMotoreB,LOW);
        analogWrite(pinMotoreE, 255);}
        break;}
            }
                    
}
void drawMenu (int posizione)
   { switch ( posizione ) {
     case 0: 
     {
       lcd.clear(); 
       for(int n=0;n<16; n++)
       {lcd.setCursor (n,0);
     lcd.write(Posizione1[n]);
     lcd.setCursor(n,1);
     lcd.write(Posizione2[n]);
     }
       lcd.setCursor(12,0);
     lcd.write("         ");
     lcd.setCursor(11,1);
    lcd.write("     "); 
     break;}
     
     case 1: {
       lcd.clear(); 
       for(int n=0;n<16; n++)
       {lcd.setCursor(n,0);
     lcd.write(Posizione2[n]);
     lcd.setCursor(n,1);
     lcd.write(Posizione3[n]);
     }
      lcd.setCursor(11,0);
     lcd.write("         ");
     lcd.setCursor(10,1);
    lcd.write("      ");
    break; }
     }
     }
         


     
void SelezionaVelocita(){}
void SelezionaDirezione(){}
void SelezionaProgramma(){}
void MotoreDestra(){
  digitalWrite(pinMotoreA,LOW);
  digitalWrite(pinMotoreB,HIGH);}
void MotoreSinistra(){
  digitalWrite(pinMotoreA,HIGH);
  digitalWrite(pinMotoreB,LOW);}
void Velocita(int valVel){
  analogWrite(pinMotoreE,valVel);}
